/*
 * This file is generated by jOOQ.
 */
package be.lghs.accounting.model;


import be.lghs.accounting.model.tables.Accounts;
import be.lghs.accounting.model.tables.Codas;
import be.lghs.accounting.model.tables.FlywaySchemaHistory;
import be.lghs.accounting.model.tables.MovementCategories;
import be.lghs.accounting.model.tables.MovementTags;
import be.lghs.accounting.model.tables.Movements;
import be.lghs.accounting.model.tables.Subscriptions;
import be.lghs.accounting.model.tables.UserAccountNumbers;
import be.lghs.accounting.model.tables.Users;
import be.lghs.accounting.model.tables.records.AccountsRecord;
import be.lghs.accounting.model.tables.records.CodasRecord;
import be.lghs.accounting.model.tables.records.FlywaySchemaHistoryRecord;
import be.lghs.accounting.model.tables.records.MovementCategoriesRecord;
import be.lghs.accounting.model.tables.records.MovementTagsRecord;
import be.lghs.accounting.model.tables.records.MovementsRecord;
import be.lghs.accounting.model.tables.records.SubscriptionsRecord;
import be.lghs.accounting.model.tables.records.UserAccountNumbersRecord;
import be.lghs.accounting.model.tables.records.UsersRecord;

import javax.annotation.processing.Generated;

import org.jooq.ForeignKey;
import org.jooq.TableField;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.Internal;


/**
 * A class modelling foreign key relationships and constraints of tables in 
 * accounting.
 */
@Generated(
    value = {
        "https://www.jooq.org",
        "jOOQ version:3.14.9",
        "schema version:accounting_0010"
    },
    comments = "This class is generated by jOOQ"
)
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class Keys {

    // -------------------------------------------------------------------------
    // UNIQUE and PRIMARY KEY definitions
    // -------------------------------------------------------------------------

    public static final UniqueKey<AccountsRecord> ACCOUNTS_NAME_KEY = Internal.createUniqueKey(Accounts.ACCOUNTS, DSL.name("accounts_name_key"), new TableField[] { Accounts.ACCOUNTS.NAME }, true);
    public static final UniqueKey<AccountsRecord> ACCOUNTS_PKEY = Internal.createUniqueKey(Accounts.ACCOUNTS, DSL.name("accounts_pkey"), new TableField[] { Accounts.ACCOUNTS.ID }, true);
    public static final UniqueKey<CodasRecord> CODAS_FILENAME_KEY = Internal.createUniqueKey(Codas.CODAS, DSL.name("codas_filename_key"), new TableField[] { Codas.CODAS.FILENAME }, true);
    public static final UniqueKey<CodasRecord> CODAS_PKEY = Internal.createUniqueKey(Codas.CODAS, DSL.name("codas_pkey"), new TableField[] { Codas.CODAS.ID }, true);
    public static final UniqueKey<FlywaySchemaHistoryRecord> FLYWAY_SCHEMA_HISTORY_PK = Internal.createUniqueKey(FlywaySchemaHistory.FLYWAY_SCHEMA_HISTORY, DSL.name("flyway_schema_history_pk"), new TableField[] { FlywaySchemaHistory.FLYWAY_SCHEMA_HISTORY.INSTALLED_RANK }, true);
    public static final UniqueKey<MovementCategoriesRecord> MOVEMENT_CATEGORIES_PKEY = Internal.createUniqueKey(MovementCategories.MOVEMENT_CATEGORIES, DSL.name("movement_categories_pkey"), new TableField[] { MovementCategories.MOVEMENT_CATEGORIES.ID }, true);
    public static final UniqueKey<MovementTagsRecord> MOVEMENT_TAGS_PKEY = Internal.createUniqueKey(MovementTags.MOVEMENT_TAGS, DSL.name("movement_tags_pkey"), new TableField[] { MovementTags.MOVEMENT_TAGS.MOVEMENT_ID, MovementTags.MOVEMENT_TAGS.CONTENT }, true);
    public static final UniqueKey<MovementsRecord> MOVEMENTS_PKEY = Internal.createUniqueKey(Movements.MOVEMENTS, DSL.name("movements_pkey"), new TableField[] { Movements.MOVEMENTS.ID }, true);
    public static final UniqueKey<SubscriptionsRecord> SUBSCRIPTIONS_PKEY = Internal.createUniqueKey(Subscriptions.SUBSCRIPTIONS, DSL.name("subscriptions_pkey"), new TableField[] { Subscriptions.SUBSCRIPTIONS.ID }, true);
    public static final UniqueKey<UserAccountNumbersRecord> USER_ACCOUNT_NUMBERS_ACCOUNT_NUMBER_KEY = Internal.createUniqueKey(UserAccountNumbers.USER_ACCOUNT_NUMBERS, DSL.name("user_account_numbers_account_number_key"), new TableField[] { UserAccountNumbers.USER_ACCOUNT_NUMBERS.ACCOUNT_NUMBER }, true);
    public static final UniqueKey<UserAccountNumbersRecord> USER_ACCOUNT_NUMBERS_PKEY = Internal.createUniqueKey(UserAccountNumbers.USER_ACCOUNT_NUMBERS, DSL.name("user_account_numbers_pkey"), new TableField[] { UserAccountNumbers.USER_ACCOUNT_NUMBERS.USER_ID, UserAccountNumbers.USER_ACCOUNT_NUMBERS.ACCOUNT_NUMBER }, true);
    public static final UniqueKey<UsersRecord> USERS_EMAIL_KEY = Internal.createUniqueKey(Users.USERS, DSL.name("users_email_key"), new TableField[] { Users.USERS.EMAIL }, true);
    public static final UniqueKey<UsersRecord> USERS_PKEY = Internal.createUniqueKey(Users.USERS, DSL.name("users_pkey"), new TableField[] { Users.USERS.UUID }, true);
    public static final UniqueKey<UsersRecord> USERS_USERNAME_KEY = Internal.createUniqueKey(Users.USERS, DSL.name("users_username_key"), new TableField[] { Users.USERS.USERNAME }, true);
    public static final UniqueKey<UsersRecord> USERS_UUID_KEY = Internal.createUniqueKey(Users.USERS, DSL.name("users_uuid_key"), new TableField[] { Users.USERS.UUID }, true);

    // -------------------------------------------------------------------------
    // FOREIGN KEY definitions
    // -------------------------------------------------------------------------

    public static final ForeignKey<CodasRecord, AccountsRecord> CODAS__CODAS_ACCOUNT_ID_FKEY = Internal.createForeignKey(Codas.CODAS, DSL.name("codas_account_id_fkey"), new TableField[] { Codas.CODAS.ACCOUNT_ID }, Keys.ACCOUNTS_PKEY, new TableField[] { Accounts.ACCOUNTS.ID }, true);
    public static final ForeignKey<MovementTagsRecord, MovementsRecord> MOVEMENT_TAGS__MOVEMENT_TAGS_MOVEMENT_ID_FKEY = Internal.createForeignKey(MovementTags.MOVEMENT_TAGS, DSL.name("movement_tags_movement_id_fkey"), new TableField[] { MovementTags.MOVEMENT_TAGS.MOVEMENT_ID }, Keys.MOVEMENTS_PKEY, new TableField[] { Movements.MOVEMENTS.ID }, true);
    public static final ForeignKey<MovementsRecord, AccountsRecord> MOVEMENTS__MOVEMENTS_ACCOUNT_ID_FKEY = Internal.createForeignKey(Movements.MOVEMENTS, DSL.name("movements_account_id_fkey"), new TableField[] { Movements.MOVEMENTS.ACCOUNT_ID }, Keys.ACCOUNTS_PKEY, new TableField[] { Accounts.ACCOUNTS.ID }, true);
    public static final ForeignKey<MovementsRecord, MovementCategoriesRecord> MOVEMENTS__MOVEMENTS_CATEGORY_ID_FKEY = Internal.createForeignKey(Movements.MOVEMENTS, DSL.name("movements_category_id_fkey"), new TableField[] { Movements.MOVEMENTS.CATEGORY_ID }, Keys.MOVEMENT_CATEGORIES_PKEY, new TableField[] { MovementCategories.MOVEMENT_CATEGORIES.ID }, true);
    public static final ForeignKey<MovementsRecord, CodasRecord> MOVEMENTS__MOVEMENTS_CODA_ID_FKEY = Internal.createForeignKey(Movements.MOVEMENTS, DSL.name("movements_coda_id_fkey"), new TableField[] { Movements.MOVEMENTS.CODA_ID }, Keys.CODAS_PKEY, new TableField[] { Codas.CODAS.ID }, true);
    public static final ForeignKey<SubscriptionsRecord, UsersRecord> SUBSCRIPTIONS__SUBSCRIPTIONS_ENCODER_ID_FKEY = Internal.createForeignKey(Subscriptions.SUBSCRIPTIONS, DSL.name("subscriptions_encoder_id_fkey"), new TableField[] { Subscriptions.SUBSCRIPTIONS.ENCODER_ID }, Keys.USERS_UUID_KEY, new TableField[] { Users.USERS.UUID }, true);
    public static final ForeignKey<SubscriptionsRecord, UsersRecord> SUBSCRIPTIONS__SUBSCRIPTIONS_MEMBER_ID_FKEY = Internal.createForeignKey(Subscriptions.SUBSCRIPTIONS, DSL.name("subscriptions_member_id_fkey"), new TableField[] { Subscriptions.SUBSCRIPTIONS.MEMBER_ID }, Keys.USERS_UUID_KEY, new TableField[] { Users.USERS.UUID }, true);
    public static final ForeignKey<SubscriptionsRecord, MovementsRecord> SUBSCRIPTIONS__SUBSCRIPTIONS_MOVEMENT_ID_FKEY = Internal.createForeignKey(Subscriptions.SUBSCRIPTIONS, DSL.name("subscriptions_movement_id_fkey"), new TableField[] { Subscriptions.SUBSCRIPTIONS.MOVEMENT_ID }, Keys.MOVEMENTS_PKEY, new TableField[] { Movements.MOVEMENTS.ID }, true);
    public static final ForeignKey<UserAccountNumbersRecord, UsersRecord> USER_ACCOUNT_NUMBERS__USER_ACCOUNT_NUMBERS_USER_ID_FKEY = Internal.createForeignKey(UserAccountNumbers.USER_ACCOUNT_NUMBERS, DSL.name("user_account_numbers_user_id_fkey"), new TableField[] { UserAccountNumbers.USER_ACCOUNT_NUMBERS.USER_ID }, Keys.USERS_UUID_KEY, new TableField[] { Users.USERS.UUID }, true);
}
